﻿using System;
using System.Windows;

class SimpleDelegateVariance
{
    static void Main()
    {
        Func<Square> squareFactory = () => new Square(new Point(5, 5), 10);
        Func<IShape> shapeFactory = squareFactory;

        Action<IShape> shapePrinter = shape => System.Console.WriteLine(shape.Area);
        Action<Square> squarePrinter = shapePrinter;

        squarePrinter(squareFactory());
        shapePrinter(shapeFactory());
    }
}
